#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "namespaceproxy4xi.py">
#<abstract4xi abstract = "provides class NamespaceProxy4xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'NamespaceProxy4Xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "

import weakref
import array
import queue
from traceback import format_exc

#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    from traceback import format_exc         
except:
    pass
try:                 # rare ones
    import array
    import queue          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import NamespaceProxy
except:
    print("namespaceproxy4xi.py *** failed in from multiprocessing.managers import NamespaceProxy ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from baseproxy4xi import BaseProxy4Xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>



#
# =================================================================================================
#<class4xi class = "NamespaceProxy4Xi" base = "BaseProxy4Xi" child = "None" synopsis = "given to SyncManager4Xi as a parameter" usage = "
#   managers.py                              
#       SyncManager.register('Namespace', Namespace, NamespaceProxy)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class NamespaceProxy4Xi(BaseProxy4Xi):
    '''
    given to SyncManager4Xi as a parameter
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('__getattribute__', '__setattr__', '__delattr__', 'sense', 'reason', 'ace')         
    #"
    #/>    


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getattr-of-NamespaceProxy4Xi" usage = "returns attribute with (self, key)">                      
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __getattr__(self, key):
        '''
        NamespaceProxy4Xi method __getattr__: returns attribute with (self, key)
        '''
        class2print = "NamespaceProxy4Xi"
        method2print = "__getattr__"
        
        message2print = "{started" + "; getattr-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                                
        
        message2print = "{passed" + "; key-passed-to-getattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
         

        if key[0] == '_':
            message2print = "{passing" + "; key-passing-to-object-getattribute-by-getattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                
            message2print = "{returning" + "; object-getattribute-function-returning-by-getattr-of-NamespaceProxy4Xi: " + str(object.__getattribute__) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                                      
              
            return object.__getattribute__(self, key)
        
        message2print = "{passing" + "; callmethod-passing-to-object-getattribute-by-getattr-of-NamespaceProxy4Xi: " + str('_callmethod') + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                        
        callmethod = object.__getattribute__(self, '_callmethod')
        
        message2print = "{got" + "; callmethod-got-by-getattr-of-NamespaceProxy4Xi: " + str(callmethod)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                         
        message2print = "{passing" + "; key-passing-to-callmethod-by-getattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{returning" + "; callmethod-function-returning-by-getattr-of-NamespaceProxy4Xi: " + str(callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                                                        

        return callmethod('__getattribute__', (key,))
        
        
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "setattr-of-NamespaceProxy4Xi" usage = "sets atribute and returnswith (self, key, value)">                          
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __setattr__(self, key, value):
        '''
        NamespaceProxy4Xi method __setattr__: sets atribute and returnswith (self, key, value) 
        '''
        class2print = "NamespaceProxy4Xi"
        method2print = "__setattr__"
        
        
        message2print = "{started" + "; setattr-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        message2print = "{passed" + "; key-passed-to-setattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{passed" + "; value-passed-to-setattr-of-NamespaceProxy4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
      
        if key[0] == '_':
                       
            message2print = "{passing" + "; key-passing-to-object-setattr-by-setattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            
            message2print = "{passing" + "; value-passing-to-object-setattr-by-setattr-of-NamespaceProxy4Xi: " + str(value) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                                          
            message2print = "{returning" + "; object-setattr-function-returning-by-setattr-of-NamespaceProxy4Xi: " + str(object.__setattr__) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                            
            
            return object.__setattr__(self, key, value)
        
            
        callmethod = object.__getattribute__(self, '_callmethod')
        
        message2print = "{set" + "; callmethod-set-by-setattr-of-NamespaceProxy4Xi to: " + str(callmethod)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
        message2print = "{returning" + "; callmethod-function-returning-by-setattr-of-NamespaceProxy4Xi: " + str(callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                                            
                
        return callmethod('__setattr__', (key, value))
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delattr-of-NamespaceProxy4Xi" usage = "deletes and returns with (self, key)">                            
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __delattr__(self, key):
        '''
        NamespaceProxy4Xi method __delattr__: deletes and returns with (self, key)
        '''
        class2print = "NamespaceProxy4Xi"
        method2print = "__delattr__"
        
        
        message2print = "{started" + "; delattr-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        message2print = "{passed" + "; key-passed-to-delattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        
        if key[0] == '_':
            message2print = "{passing" + "; key-passing-to-object-delattr-by-delattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
        
            message2print = "{returning" + "; object-delattr-function-returning-by-delattr-of-NamespaceProxy4Xi: " + str(object.__delattr__) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                            
            return object.__delattr__(self, key)
        
            
        callmethod = object.__getattribute__(self, '_callmethod')
        
        message2print = "{set" + "; callmethod-set-by-delattr-of-NamespaceProxy4Xi to: " + str(callmethod)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
        message2print = "{passing" + "; key-passing-to-callmethod-by-delattr-of-NamespaceProxy4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{returning" + "; callmethod-function-returning-by-delattr-of-NamespaceProxy4Xi: " + str(callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                                                       
         
        return callmethod('__delattr__', (key,))
    #</methodize4xi>
            

    
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-NamespaceProxy4Xi" usage = "senses NamespaceProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses NamespaceProxy4Xi class objects
        '''
 
        
        class2print = 'NamespaceProxy4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; NamespaceProxy4Xi-sensing-by-sense-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-NamespaceProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-namespaceproxy2xi'] = BaseProxy4Xi  
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-NamespaceProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
      
        message2print = "{sensed" + "; NamespaceProxy4Xi-sensed-by-sense-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-NamespaceProxy4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                          
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-NamespaceProxy4Xi" usage = "reasons NamespaceProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons NamespaceProxy4Xi class objects
        '''
  
        
        class2print = 'NamespaceProxy4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; NamespaceProxy4Xi-reasoning-by-reason-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-NamespaceProxy4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; NamespaceProxy4Xi-reasoned-by-reason-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-NamespaceProxy4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                          
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-NamespaceProxy4Xi" usage = "aces NamespaceProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces NamespaceProxy4Xi class objects 
        '''

        
        
        class2print = 'NamespaceProxy4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-NamespaceProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; NamespaceProxy4Xi-acing-by-ace-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-NamespaceProxy4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; NamespaceProxy4Xi-aced-by-ace-of-NamespaceProxy4Xi: " + str(NamespaceProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-NamespaceProxy4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of namespaceproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



